#!/usr/bin/perl

use strict;
use warnings;

BEGIN {
    if ($0 =~ m|^(.*)/[^/]+$|) {
        push(@INC, $1);
    }
}

use SOAP::Lite;
use MIME::Base64;
use HPSMSOAP;

my $site = 'http://bp4smdemo.hpsweducation.com:13080/SM/7';
my $user = 'falcon';
my $password = 'orange perfection';
my $auth = encode_base64("$user:$password", '');

my $soap = SOAP::Lite->new(
    proxy => "$site/ws",
    service => "$site/ServiceDesk.wsdl",
    default_ns => $site);
$soap->transport->http_request->header('Authorization' => "Basic $auth");
$soap->on_action(sub { '"Create"'; } );

my $keys = SOAP::Data->name('keys' => '')->type('');
my $instance = SOAP::Data->name('instance' => '')->type('');
my $model = SOAP::Data->name('model' => \SOAP::Data->value($keys, $instance));
my $som = $soap->call('CreateInteraction', $model);

#soapfault($som);
#soapstatus($som);
#soapdata($som, '//CreateInteractionResponse/messages', 1);
#soapdata($som, '//CreateInteractionResponse/model', 0);
print $som->valueof('//CreateInteractionResponse/model/keys/CallID') . "\n";
